package org.jboss.soa.esb.samples.quickstart.helloworld;

import org.jboss.aop.advice.Interceptor;
import org.jboss.aop.joinpoint.Invocation;

import org.jboss.aop.joinpoint.ConstructorInvocation;
import org.jboss.aop.joinpoint.FieldWriteInvocation;
import org.jboss.aop.joinpoint.MethodInvocation;

public class LoggingAspect implements Interceptor
{

	@Override
	public String getName() {
  		return "LogInterceptor";
	}


	@Override
	public Object invoke(Invocation invocation) throws Throwable {
		System.out.println("###############################Hello Interceptor##############################");
  		long time=System.currentTimeMillis();
  		try {
   		 return invocation.invokeNext();
  		} finally 
		  {
    			time=System.currentTimeMillis()-time;
    			if (invocation instanceof MethodInvocation) {
     				MethodInvocation mi = (MethodInvocation) invocation;
      				String clazz="";
      				try 
				{
        				clazz=mi.getTargetObject().getClass().toString(); 
					System.out.println("###############################Hello Interceptor##############################");
					System.out.println("This class is intercepted: "+clazz);
				}
				catch (Throwable e) 
				{
        				// TODO: handle exception
      				}
      			//Here you can use a logger to log time and method name
      			 }
		}
 	}

}
